<!DOCTYPE html>
<html>

<head>
  <meta charset="UTF-8">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
</head>

<body>
  <div class="container mt-4">
    <h2>Lucky Dice Username</h2>
    <div class="form-group">
      <label for="username">User name:</label>
      <input type="email" class="form-control" id="inp-username" placeholder="Enter username" name="username">
    </div>
    <div class="form-group">
      <button type="button" onclick="onBtnShowPresentClick()" class="btn btn-primary">Show Present History
        Table</button>
    </div>
    <div id="log-result" class="mt-5"></div>
    <div class="mt-5">
      <table id="table-dice-history" class="table table-striped table-bordered table-hover">
        <thead>
          <tr>
            <th>Game</th>
            <th>Present</th>
          </tr>
        </thead>
        <tbody>

        </tbody>
      </table>
    </div>
  </div>

  <script>
    'use strict';
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gEND_OF_ROW_COL = -1;
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm xử lý sự kiện onclick
    function onBtnShowDiceClick() {
      //Kai báo đối tượng UserObj
      var vUserObj = {
        userName: ""
      };
      //B1: Tu thập dữ liệu
      thuThapDuLieu(vUserObj);
      //B2: validate, kiểm tra dữ liệu
      var vDuLieuHopLe = validate(vUserObj);
      if (vDuLieuHopLe) {
        var vXmlHttpDiceHistory = new XMLHttpRequest();
        //B3: Gọi API để lấy dữ liệu lịch sự tung xx
        callAPI(vUserObj, vXmlHttpDiceHistory);
        //B4: hiển thị lịch sự tung xx vào table
        vXmlHttpDiceHistory.onreadystatechange =
          function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
              hienThiLichSuTungXucXac(vXmlHttpDiceHistory);
            }
          }
      };
    }

    function onBtnShowPresentClick() {
      //Khai báo đối tượng UserObj
      var vUserObj = {
        userName: ""
      };
      //B1: thu thập dữ liệu
      thuThapDuLieu(vUserObj);
      //B2: validate dữ liệu
      var vDuLieuHopLe = validate(vUserObj);
      if (vDuLieuHopLe) {
        var vXmlHttpPrizeHistory = new XMLHttpRequest();
        //B3: Gọi Api lấy dữ liệu phần thưởng
        CallAPI(vUserObj, vXmlHttpPrizeHistory);
        //B4: hiển thị lịch sự prize
        vXmlHttpPrizeHistory.onreadystatechange =
          function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
              hienThiDuLieuPrize(vXmlHttpPrizeHistory);
            }
          }
      }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //Hàm thu thập dữ liệu
    function thuThapDuLieu(paramUserObj) {
      var vUserNameInp = document.getElementById("inp-username");
      paramUserObj.userName = vUserNameInp.value.trim();
    }
    //validate data
    function validate(paramUserObj) {
      if (paramUserObj.userName == "") {
        alert("Phải nhập vào username");
        return false;
      }
      return true;
    }
    //Hàm thực hiện gọi API
    function callAPI(paramUserObj, paramXmlHttp) {
      paramXmlHttp.open("GET", gBASE_URL + "/dice-history?username=" + paramUserObj.userName, true);
      paramXmlHttp.send();
    }

    function CallAPI(paramUserObj, paramXmlHttp) {
      paramXmlHttp.open("GET", gBASE_URL + "/prize-history?username=" + paramUserObj.userName, true);
      paramXmlHttp.send();
    }
    //Hàm hiển thị lịch sự tung xx
    function hienThiLichSuTungXucXac(paramXmlHttp) {
      console.log(paramXmlHttp.responseText)
      var vDiceHistoryObj = JSON.parse(paramXmlHttp.responseText);
      var vDiceHistoryTable = document.getElementById("table-dice-history");
      var vDiceHistoryTBody = vDiceHistoryTable.getElementsByTagName("tbody")[0];
      //xóa trắng bảng dữ liệu
      vDiceHistoryTBody.innerHTML = "";
      for (var bI = 0; bI < vDiceHistoryObj.dices.length; bI++) {
        //thêm 1 dòng mới gắn vào table
        var bNewRow = vDiceHistoryTBody.insertRow(gEND_OF_ROW_COL);
        //thêm 2 ô trên dòng mới
        var bGameCell = bNewRow.insertCell(0);
        var bDiceCell = bNewRow.insertCell(1);
        //điền dữ liệu cho từng ô
        bGameCell.innerHTML = bI + 1;
        bDiceCell.innerHTML = vDiceHistoryObj.dices[bI];
      };
    }

    function hienThiDuLieuPrize(paramXmlHttp) {
      var vPrizeHistory = paramXmlHttp.responseText;
      console.log(vPrizeHistory);
      var vPrizeHistoryObj = JSON.parse(paramXmlHttp.responseText);
      var vPrizeHistoryTable = document.getElementById("table-dice-history");
      var vPrizeHistoryTBody = vPrizeHistoryTable.getElementsByTagName("tbody")[0];
      //Xóa trắng
      vPrizeHistoryTBody.innerHTML = "";
      for (var bI = 0; bI < vPrizeHistoryObj.prizes.length; bI++) {
        //thêm 1 dòng mới gắn vào table
        var bNewRow = vPrizeHistoryTBody.insertRow(gEND_OF_ROW_COL);
        //thêm 2 ô trên dòng mới
        var bGameCell = bNewRow.insertCell(0);
        var bPresentCell = bNewRow.insertCell(1);
        //điền dữ liệu cho từng ô
        bGameCell.innerHTML = bI + 1;
        bPresentCell.innerHTML = vPrizeHistoryObj.prizes[bI];
      };
    }
  </script>


</body>

</html>